<template>
  <li :class="getClass" :title="props.task.title" :style="style">
    <span class="TaskPreview__Title">{{ label }}</span>
    <span v-if="subtitle" class="TaskPreview__Subtitle">{{ subtitle }}</span>
    <span class="TaskPreview__StartDate">{{ displayStartDate }}</span>
    <span class="TaskPreview__EndDate">{{ displayEndDate }}</span>
  </li>
</template>

<script lang="ts" setup>
import { Task } from '@/api'
import { computed, toRef, toRefs } from 'vue'
import { useI18n } from 'vue-i18n'
import moment from 'moment-timezone'
import { handleOutOfBound } from '@/pages/weekPlanning/timedPosition'
import { useTaskLabel } from '@/pages/weekPlanning/useTaskLabel'
import { useTaskColor } from '@/pages/weekPlanning/useTaskColor'

const props = defineProps<{
  task: Task
}>()
const { task } = toRefs(props)

const { t } = useI18n()

const { startBefore, endAfter } = handleOutOfBound(toRef(props, 'task'))

const displayStartDate = computed(() =>
  moment(props.task.startDate).format(startBefore.value ? 'L LT' : 'LT')
)
const displayEndDate = computed(() =>
  moment(props.task.estimatedEndMax).format(endAfter.value ? 'L LT' : 'LT')
)

const { label, subtitle } = useTaskLabel(task)

const getClass = computed(() => ({
  TaskPreview: true,
  'TaskPreview--startBefore': startBefore.value,
  'TaskPreview--endAfter': endAfter.value,
}))

const { style } = useTaskColor(task)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use './task' as t;

.TaskPreview {
  @include t.task;

  opacity: 0.8;
  pointer-events: none;
}
</style>
